(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/forms'), require('rxjs/operators'), require('rxjs'), require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('nthm', ['exports', '@angular/common', '@angular/forms', 'rxjs/operators', 'rxjs', '@angular/core'], factory) :
    (factory((global.nthm = {}),global.ng.common,global.ng.forms,global.rxjs.operators,global.rxjs,global.ng.core));
}(this, (function (exports,common,forms,operators,rxjs,core) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
     */
    /** @enum {number} */
    var Key = {
        Backspace: 8,
        Tab: 9,
        Enter: 13,
        Shift: 16,
        Escape: 27,
        Space: 32,
        End: 35,
        Home: 36,
        ArrowLeft: 37,
        ArrowUp: 38,
        ArrowRight: 39,
        ArrowDown: 40,
    };
    Key[Key.Backspace] = 'Backspace';
    Key[Key.Tab] = 'Tab';
    Key[Key.Enter] = 'Enter';
    Key[Key.Shift] = 'Shift';
    Key[Key.Escape] = 'Escape';
    Key[Key.Space] = 'Space';
    Key[Key.End] = 'End';
    Key[Key.Home] = 'Home';
    Key[Key.ArrowLeft] = 'ArrowLeft';
    Key[Key.ArrowUp] = 'ArrowUp';
    Key[Key.ArrowRight] = 'ArrowRight';
    Key[Key.ArrowDown] = 'ArrowDown';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
     */
    /** @type {?} */
    var styleProperties = Object.freeze([
        'direction',
        'boxSizing',
        'width',
        'height', 'overflowX',
        'overflowY',
        'borderTopWidth', 'borderRightWidth', 'borderBottomWidth', 'borderLeftWidth', 'borderStyle',
        'paddingTop', 'paddingRight', 'paddingBottom', 'paddingLeft',
        // https://developer.mozilla.org/en-US/docs/Web/CSS/font
        'fontStyle', 'fontVariant', 'fontWeight', 'fontStretch', 'fontSize', 'fontSizeAdjust', 'lineHeight', 'fontFamily',
        'textAlign', 'textTransform', 'textIndent',
        'textDecoration',
        'letterSpacing', 'wordSpacing',
        'tabSize', 'MozTabSize'
    ]);
    /** @type {?} */
    var isBrowser = typeof window !== 'undefined';
    /** @type {?} */
    var isFirefox = isBrowser && (( /** @type {?} */(window))).mozInnerScreenX != null;
    /**
     * @param {?=} element
     * @return {?}
     */
    function isInputOrTextAreaElement(element) {
        return element !== null &&
            (element.nodeName === 'INPUT' || element.nodeName === 'TEXTAREA' || element.nodeName === '#text');
    }
    /**
     * @param {?} value
     * @param {?} start
     * @param {?} end
     * @param {?} insert
     * @return {?}
     */
    function spliceString(value, start, end, insert) {
        return value.substring(0, start) + insert + value.substring(end) + '';
    }
    /**
     * @param {?} value
     * @param {?} mentionMarkup
     * @param {?} textIterator
     * @param {?} markupIterator
     * @param {?} displayTransform
     * @return {?}
     */
    function iterateMentionsMarkup(value, mentionMarkup, textIterator, markupIterator, displayTransform) {
        /** @type {?} */
        var match;
        /** @type {?} */
        var start = 0;
        /** @type {?} */
        var currentPlainTextIndex = 0;
        /** @type {?} */
        var regEx = mentionMarkup.regEx;
        regEx.lastIndex = 0;
        while ((match = regEx.exec(value)) !== null) {
            /** @type {?} */
            var display = displayTransform.apply(void 0, __spread(match));
            /** @type {?} */
            var substr = value.substring(start, match.index);
            textIterator(substr, start, currentPlainTextIndex);
            currentPlainTextIndex += substr.length;
            markupIterator(match[0], match.index, currentPlainTextIndex, display);
            currentPlainTextIndex += display.length;
            start = regEx.lastIndex;
        }
        if (start < value.length) {
            textIterator(value.substring(start), start, currentPlainTextIndex);
        }
    }
    /**
     * @param {?} value
     * @param {?} mentionMarkup
     * @param {?} markupIterator
     * @param {?} displayTransform
     * @return {?}
     */
    function iterateOnlyMentionsMarkup(value, mentionMarkup, markupIterator, displayTransform) {
        /** @type {?} */
        var match;
        /** @type {?} */
        var start = 0;
        /** @type {?} */
        var currentPlainTextIndex = 0;
        /** @type {?} */
        var regEx = mentionMarkup.regEx;
        regEx.lastIndex = 0;
        while ((match = regEx.exec(value)) !== null) {
            /** @type {?} */
            var display = displayTransform.apply(void 0, __spread(match));
            /** @type {?} */
            var substr = value.substring(start, match.index);
            currentPlainTextIndex += substr.length;
            markupIterator(match[0], match.index, currentPlainTextIndex, display);
            currentPlainTextIndex += display.length;
            start = regEx.lastIndex;
        }
    }
    /**
     * @param {?} value
     * @param {?} mentionMarkup
     * @param {?} indexInPlainText
     * @param {?} toEndOfMarkup
     * @param {?} displayTransform
     * @return {?}
     */
    function mapPlainTextIndex(value, mentionMarkup, indexInPlainText, toEndOfMarkup, displayTransform) {
        if (isNaN(indexInPlainText)) {
            return indexInPlainText;
        }
        /** @type {?} */
        var result;
        /** @type {?} */
        var textIterator = function (matchString, index, substringPlainTextIndex) {
            if (typeof result !== 'undefined') {
                return;
            }
            if (substringPlainTextIndex + matchString.length >= indexInPlainText) {
                result = index + indexInPlainText - substringPlainTextIndex;
            }
        };
        /** @type {?} */
        var markupIterator = function (matchString, index, mentionPlainTextIndex, display) {
            if (typeof result !== 'undefined') {
                return;
            }
            if (mentionPlainTextIndex + display.length > indexInPlainText) {
                result = index + (toEndOfMarkup ? matchString.length : 0);
            }
        };
        iterateMentionsMarkup(value, mentionMarkup, textIterator, markupIterator, displayTransform);
        return typeof result !== 'undefined' ? result : value.length;
    }
    /**
     * @param {?} element
     * @return {?}
     */
    function getCaretPosition(element) {
        if (isInputOrTextAreaElement(element)) {
            /** @type {?} */
            var value = element.value;
            return value.slice(0, element.selectionStart).length;
        }
        /** @type {?} */
        var selection = window.getSelection();
        if (selection.rangeCount > 0) {
            /** @type {?} */
            var range = selection.getRangeAt(0);
            return range.startOffset;
        }
        return 0;
    }
    /**
     * @param {?} element
     * @param {?} position
     * @return {?}
     */
    function getCaretCoordinates(element, position) {
        /** @type {?} */
        var coords = { top: 0, left: 0 };
        if (!isBrowser) {
            return coords;
        }
        /** @type {?} */
        var div = document.createElement('div');
        document.body.appendChild(div);
        /** @type {?} */
        var style = div.style;
        /** @type {?} */
        var computed = window.getComputedStyle ? getComputedStyle(element) : (( /** @type {?} */(element))).currentStyle;
        style.whiteSpace = 'pre-wrap';
        if (element.nodeName !== 'INPUT') {
            style.wordWrap = 'break-word';
        }
        style.position = 'absolute';
        style.visibility = 'hidden';
        styleProperties.forEach(function (prop) { return style[prop] = computed[prop]; });
        if (isFirefox) {
            if (element.scrollHeight > parseInt(computed.height, 10)) {
                style.overflowY = 'scroll';
            }
        }
        else {
            style.overflow = 'hidden';
        }
        div.textContent = element.value.substring(0, position);
        if (element.nodeName === 'INPUT') {
            div.textContent = div.textContent.replace(/\s/g, '\u00a0');
        }
        /** @type {?} */
        var span = document.createElement('span');
        span.textContent = element.value.substring(position) || '.';
        div.appendChild(span);
        coords = {
            top: span.offsetTop + parseInt(computed['borderTopWidth'], 10),
            left: span.offsetLeft + parseInt(computed['borderLeftWidth'], 10)
        };
        document.body.removeChild(div);
        return coords;
    }
    /**
     * @param {?} element
     * @param {?} position
     * @return {?}
     */
    function setCaretPosition(element, position) {
        if (isInputOrTextAreaElement(element) && element.selectionStart !== undefined) {
            element.focus();
            element.setSelectionRange(position, position);
        }
        else {
            /** @type {?} */
            var range = document.createRange();
            range.setStart(element, position);
            range.collapse(true);
            /** @type {?} */
            var selection = window.getSelection();
            selection.removeAllRanges();
            selection.addRange(range);
        }
    }
    /**
     * @param {?} str
     * @return {?}
     */
    function escapeRegExp(str) {
        return str.replace(/[-\/\\^$*+?.()|[\]{}]/g, '\\$&');
    }
    /**
     * @param {?} markup
     * @return {?}
     */
    function markupToRegExp(markup) {
        /** @type {?} */
        var markupPattern = escapeRegExp(markup);
        /** @type {?} */
        var placeholderRegExp = /__([\w]+)__/g;
        /** @type {?} */
        var placeholders = {};
        /** @type {?} */
        var groups = /[\[\]()]+/.test(markup);
        /** @type {?} */
        var match;
        /** @type {?} */
        var i = groups ? 1 : 0;
        /** @type {?} */
        var placeholderExclusion = groups ? '^\\)\\]' : '\\S';
        do {
            match = placeholderRegExp.exec(markupPattern);
            if (match) {
                /** @type {?} */
                var placeholder = match[1];
                markupPattern = markupPattern.replace("__" + placeholder + "__", "([" + placeholderExclusion + "]+)");
                placeholders[placeholder] = ++i;
            }
        } while (match);
        return { markup: markup, regEx: new RegExp('(' + markupPattern + ')', 'ig'), groups: placeholders };
    }
    /**
     * @param {?} value
     * @param {?} mentionMarkup
     * @param {?} displayTransform
     * @return {?}
     */
    function getPlainText(value, mentionMarkup, displayTransform) {
        mentionMarkup.regEx.lastIndex = 0;
        return value.replace(mentionMarkup.regEx, displayTransform);
    }
    /**
     * @param {?} item
     * @param {?} markupMention
     * @return {?}
     */
    function replacePlaceholders(item, markupMention) {
        /** @type {?} */
        var result = markupMention.markup + '';
        Object.keys(markupMention.groups)
            .forEach(function (key) { return result = result.replace(new RegExp("__" + key + "__", 'g'), typeof item === 'string' ? item : item[key]); });
        return result;
    }
    /**
     * @param {?} value
     * @param {?} markupMention
     * @param {?} plainTextValue
     * @param {?=} selectionStartBeforeChange
     * @param {?=} selectionEndBeforeChange
     * @param {?=} selectionEndAfterChange
     * @param {?=} displayTransform
     * @return {?}
     */
    function applyChangeToValue(value, markupMention, plainTextValue, selectionStartBeforeChange, selectionEndBeforeChange, selectionEndAfterChange, displayTransform) {
        if (selectionStartBeforeChange === void 0) {
            selectionStartBeforeChange = 0;
        }
        if (selectionEndBeforeChange === void 0) {
            selectionEndBeforeChange = 0;
        }
        if (selectionEndAfterChange === void 0) {
            selectionEndAfterChange = 0;
        }
        /** @type {?} */
        var oldPlainTextValue = getPlainText(value, markupMention, displayTransform);
        /** @type {?} */
        var lengthDelta = oldPlainTextValue.length - plainTextValue.length;
        if (!selectionEndBeforeChange) {
            selectionEndBeforeChange = selectionStartBeforeChange;
        }
        if (selectionStartBeforeChange === selectionEndBeforeChange && selectionEndBeforeChange === selectionEndAfterChange &&
            oldPlainTextValue.length === plainTextValue.length) {
            selectionStartBeforeChange--;
        }
        /** @type {?} */
        var insert = plainTextValue.slice(selectionStartBeforeChange, selectionEndAfterChange);
        /** @type {?} */
        var spliceStart = Math.min(selectionStartBeforeChange, selectionEndAfterChange);
        /** @type {?} */
        var spliceEnd = selectionEndBeforeChange;
        if (selectionStartBeforeChange === selectionEndAfterChange) {
            spliceEnd = Math.max(selectionEndBeforeChange, selectionStartBeforeChange + lengthDelta);
        }
        return spliceString(value, mapPlainTextIndex(value, markupMention, spliceStart, false, displayTransform), mapPlainTextIndex(value, markupMention, spliceEnd, true, displayTransform), insert);
    }
    /**
     * @param {?} value
     * @param {?} mentionMarkup
     * @param {?} indexInPlainText
     * @param {?} displayTransform
     * @return {?}
     */
    function findStartOfMentionInPlainText(value, mentionMarkup, indexInPlainText, displayTransform) {
        /** @type {?} */
        var result = { start: -1, end: -1 };
        /** @type {?} */
        var markupIterator = function (matchString, index, mentionPlainTextIndex, display) {
            if (mentionPlainTextIndex < indexInPlainText && mentionPlainTextIndex + display.length > indexInPlainText) {
                result = { start: mentionPlainTextIndex, end: mentionPlainTextIndex + display.length };
                return true;
            }
            return false;
        };
        iterateOnlyMentionsMarkup(value, mentionMarkup, markupIterator, displayTransform);
        return result;
    }
    /**
     * @param {?} value
     * @param {?} mentionMarkup
     * @param {?} indexInPlainText
     * @param {?} displayTransform
     * @return {?}
     */
    function getBoundsOfMentionAtPosition(value, mentionMarkup, indexInPlainText, displayTransform) {
        return findStartOfMentionInPlainText(value, mentionMarkup, indexInPlainText, displayTransform);
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
     */
    var NgMentionsListComponent = /** @class */ (function () {
        function NgMentionsListComponent() {
            this.activeIndex = -1;
            this.itemSelected = new core.EventEmitter();
            this.show = false;
            this.dropUp = false;
            this._top = 0;
            this._left = 0;
        }
        Object.defineProperty(NgMentionsListComponent.prototype, "selectedItem", {
            get: /**
             * @return {?}
             */ function () {
                return this.activeIndex >= 0 && this.items[this.activeIndex] !== undefined ? this.items[this.activeIndex] : null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgMentionsListComponent.prototype, "top", {
            get: /**
             * @return {?}
             */ function () {
                return this._top + this.adjustTop + 'px';
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgMentionsListComponent.prototype, "left", {
            get: /**
             * @return {?}
             */ function () {
                return this._left + 'px';
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgMentionsListComponent.prototype, "noItems", {
            get: /**
             * @return {?}
             */ function () {
                return !Array.isArray(this.items) || this.items.length === 0;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        NgMentionsListComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                if (!this.itemTemplate) {
                    this.itemTemplate = this.defaultItemTemplate;
                }
            };
        /**
         * @param {?} event
         * @param {?} activeIndex
         * @param {?} item
         * @return {?}
         */
        NgMentionsListComponent.prototype.onItemClick = /**
         * @param {?} event
         * @param {?} activeIndex
         * @param {?} item
         * @return {?}
         */
            function (event, activeIndex, item) {
                event.preventDefault();
                this.activeIndex = activeIndex;
                this.itemSelected.emit(item);
            };
        /**
         * @return {?}
         */
        NgMentionsListComponent.prototype.selectFirstItem = /**
         * @return {?}
         */
            function () {
                this.activeIndex = 0;
                this.resetScroll();
            };
        /**
         * @return {?}
         */
        NgMentionsListComponent.prototype.selectPreviousItem = /**
         * @return {?}
         */
            function () {
                if (this.activeIndex > 0) {
                    this.activeIndex--;
                }
                this.scrollToActiveItem();
            };
        /**
         * @return {?}
         */
        NgMentionsListComponent.prototype.selectNextItem = /**
         * @return {?}
         */
            function () {
                if (this.activeIndex < this.items.length - 1) {
                    this.activeIndex++;
                    this.scrollToActiveItem();
                }
            };
        /**
         * @return {?}
         */
        NgMentionsListComponent.prototype.selectLastItem = /**
         * @return {?}
         */
            function () {
                this.activeIndex = this.items.length > 0 ? this.items.length - 1 : 0;
                this.scrollToActiveItem();
            };
        /**
         * @return {?}
         */
        NgMentionsListComponent.prototype.position = /**
         * @return {?}
         */
            function () {
                var _this = this;
                /** @type {?} */
                var element = this.textAreaElement;
                /** @type {?} */
                var coords = getCaretCoordinates(element, element.selectionStart);
                console.log('coords.top', coords.top);
                console.log('this.textAreaElement.parentElement.offsetTop', this.textAreaElement.parentElement.offsetTop);
                this._top = coords.top + this.textAreaElement.parentElement.offsetTop;
                this._left = coords.left + element.offsetLeft;
                this.list.nativeElement.scrollTop = 0;
                setTimeout(function () {
                    /** @type {?} */
                    var rect = _this.list.nativeElement.getBoundingClientRect();
                    if (rect.x + rect.width > window.innerWidth) {
                        /** @type {?} */
                        var calcLeft = _this._left - Math.abs(window.innerWidth - (rect.x + rect.width));
                        _this._left = calcLeft > 0 ? calcLeft : 0;
                    }
                });
            };
        /**
         * @return {?}
         */
        NgMentionsListComponent.prototype.resetScroll = /**
         * @return {?}
         */
            function () {
                this.list.nativeElement.scrollTop = 0;
            };
        /**
         * @param {?} item
         * @return {?}
         */
        NgMentionsListComponent.prototype.transformItem = /**
         * @param {?} item
         * @return {?}
         */
            function (item) {
                return this.displayTransform(item) || item;
            };
        Object.defineProperty(NgMentionsListComponent.prototype, "adjustTop", {
            get: /**
             * @return {?}
             */ function () {
                /** @type {?} */
                var adjust = 0;
                if (!this.dropUp) {
                    /** @type {?} */
                    var computed = getComputedStyle(this.textAreaElement);
                    adjust = parseInt(computed.fontSize, 10) + this.textAreaElement.offsetTop;
                }
                return adjust;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        NgMentionsListComponent.prototype.scrollToActiveItem = /**
         * @return {?}
         */
            function () {
                var _this = this;
                /** @type {?} */
                var element = ( /** @type {?} */(this.list.nativeElement));
                setTimeout(function () {
                    if (_this.activeIndex === 0) {
                        element.scrollTop = 0;
                    }
                    else {
                        /** @type {?} */
                        var activeElement = ( /** @type {?} */(element.querySelector('li.active')));
                        if (activeElement) {
                            element.scrollTop = activeElement.offsetTop;
                        }
                    }
                });
            };
        NgMentionsListComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'mentions-list',
                        template: "\n      <ng-template #defaultItemTemplate let-item=\"item\">\n          {{transformItem(item)}}\n      </ng-template>\n      <ng-template #defaultHeaderTemplate let-item=\"item\">\n          {{item.type | titlecase}}s:\n      </ng-template>\n      <ul #list class=\"dropdown-menu scrollable-menu\">\n          <li *ngFor=\"let item of items; let i = index\" [class.active]=\"activeIndex === i\">\n              <span class=\"dropdown-header\" *ngIf=\"headerTemplate && (i === 0 || item.type !== items[i-1].type)\">\n                  <ng-template [ngTemplateOutlet]=\"headerTemplate || defaultHeaderTemplate\"\n                               [ngTemplateOutletContext]=\"{item:item,index:i}\"></ng-template>\n              </span>\n              <a href class=\"dropdown-item\" (mousedown)=\"onItemClick($event, i, item)\" >\n                  <ng-template [ngTemplateOutlet]=\"itemTemplate\"\n                               [ngTemplateOutletContext]=\"{item:item,index:i}\"></ng-template>\n              </a>\n          </li>\n      </ul>\n  ",
                        encapsulation: core.ViewEncapsulation.None,
                        styles: ['mentions-list {position: absolute;display: none;}', 'mentions-list.drop-up {transform: translateY(-100%);}',
                            'mentions-list.show {display: block;} mentions-list.no-items {display: none;}',
                            'mentions-list .scrollable-menu {display: block;height: auto;max-height:300px;overflow:auto;}',
                            'mentions-list li.active a {background: #f7f7f9;}',
                            'mentions-list li .dropdown-header {display: block;}']
                    }] }
        ];
        NgMentionsListComponent.propDecorators = {
            defaultItemTemplate: [{ type: core.ViewChild, args: ['defaultItemTemplate',] }],
            defaultHeaderTemplate: [{ type: core.ViewChild, args: ['defaultHeaderTemplate',] }],
            list: [{ type: core.ViewChild, args: ['list',] }],
            show: [{ type: core.HostBinding, args: ['class.show',] }],
            dropUp: [{ type: core.HostBinding, args: ['class.drop-up',] }],
            top: [{ type: core.HostBinding, args: ['style.top',] }],
            left: [{ type: core.HostBinding, args: ['style.left',] }],
            noItems: [{ type: core.HostBinding, args: ['class.no-items',] }]
        };
        return NgMentionsListComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
     */
    /**
     * The Mentions Component
     */
    var NgMentionsComponent = /** @class */ (function () {
        function NgMentionsComponent(element, componentResolver, viewContainer, changeDetector, ngZone) {
            this.element = element;
            this.componentResolver = componentResolver;
            this.viewContainer = viewContainer;
            this.changeDetector = changeDetector;
            this.ngZone = ngZone;
            /**
             * The character to trigger the mentions list when a user is typing in the input field
             */
            this.triggerChar = '@';
            this.includeTriggerChar = false;
            /**
             * The markup used to format a mention in the model value
             */
            this.mentionMarkup = '@[__display__](__type__:__id__)';
            /**
             * Optional. When using a custom search (i.e. an API call), the internal searching capability should be disabled.
             */
            this.disableSearch = false;
            /**
             * Only used when internal search is not disabled. This limits the maximum number of items to display in the search
             * result list.
             */
            this.maxItems = -1;
            /**
             * Used to cause the search result list to display in a "drop up" fashion, instead of a typical dropdown.
             */
            this.dropUp = false;
            /**
             * If the supplied mentions are a list of objects, this is the name of the property used to display
             * the mention in the search result list and when formatting a mention in the displayed text.
             */
            this.displayName = 'display';
            this.autoexpand = false;
            this.commitOnCMDEnter = false;
            /**
             * An event emitted, after the trigger character has been typed, with the user-entered search string.
             */
            this.search = new core.EventEmitter();
            this.valueChanges = new core.EventEmitter();
            this.stateChanges = new rxjs.Subject();
            this.focusIn = new core.EventEmitter();
            this.focusLost = new core.EventEmitter();
            this.escapePressed = new core.EventEmitter();
            this.cmdEnter = new core.EventEmitter();
            this.focused = false;
            this.empty = false;
            this.displayContent = '';
            this.lines = [];
            this.highlighterStyle = {};
            this.textAreaClassNames = {};
            this.mentions = [];
            this.inputFallback = false;
            this._value = '';
            this._rows = 1;
            this._columns = 1;
            this.stopSearch = false;
            this.markupSearch = markupToRegExp(this.mentionMarkup);
            this._destroyed = new rxjs.Subject();
            this.newLine = /\n/g;
            this._errorState = false;
        }
        Object.defineProperty(NgMentionsComponent.prototype, "formClass", {
            /**
             * Classes for textarea
             */
            get: /**
             * Classes for textarea
             * @return {?}
             */ function () {
                return Object.keys(this.textAreaClassNames).join(' ');
            },
            set: /**
             * @param {?} classNames
             * @return {?}
             */ function (classNames) {
                var _this = this;
                this.textAreaClassNames = {};
                Array.from(classNames.split(' ')).forEach(function (className) {
                    _this.textAreaClassNames[className] = true;
                });
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgMentionsComponent.prototype, "value", {
            get: /**
             * @return {?}
             */ function () {
                return this._value;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */ function (value) {
                this.parseLines(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgMentionsComponent.prototype, "required", {
            get: /**
             * @return {?}
             */ function () {
                return this._required;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */ function (value) {
                this._required = value;
                this.refreshStyles();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgMentionsComponent.prototype, "disabled", {
            get: /**
             * @return {?}
             */ function () {
                return this._disabled;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */ function (value) {
                this._disabled = value;
                this.refreshStyles();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgMentionsComponent.prototype, "rows", {
            get: /**
             * @return {?}
             */ function () {
                return this._rows;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */ function (value) {
                this._rows = Math.max(1, ( /** @type {?} */(value)));
                this.refreshStyles();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgMentionsComponent.prototype, "columns", {
            get: /**
             * @return {?}
             */ function () {
                return this._columns;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */ function (value) {
                this._columns = Math.max(1, ( /** @type {?} */(value)));
                this.refreshStyles();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgMentionsComponent.prototype, "mentionItems", {
            /**
             * The list of mentions to display, or filter, in the search result list.
             */
            set: /**
             * The list of mentions to display, or filter, in the search result list.
             * @param {?} value
             * @return {?}
             */ function (value) {
                this.mentions = value;
                if (this.disableSearch && this.mentionsList) {
                    this.mentionsList.items = value;
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgMentionsComponent.prototype, "readonly", {
            get: /**
             * @return {?}
             */ function () {
                return this.disabled ? 'readonly' : null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgMentionsComponent.prototype, "errorState", {
            get: /**
             * @return {?}
             */ function () {
                return this._errorState;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        NgMentionsComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                this.parseMarkup();
            };
        /**
         * @param {?} changes
         * @return {?}
         */
        NgMentionsComponent.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
            function (changes) {
                if ('markup' in changes) {
                    this.parseMarkup();
                }
            };
        /**
         * @return {?}
         */
        NgMentionsComponent.prototype.ngAfterViewInit = /**
         * @return {?}
         */
            function () {
                this.parseLines(this._value);
                this.refreshStyles();
            };
        /**
         * @return {?}
         */
        NgMentionsComponent.prototype.ngAfterViewChecked = /**
         * @return {?}
         */
            function () {
                this.refreshStyles();
            };
        /**
         * @return {?}
         */
        NgMentionsComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                this._destroyed.next();
                this._destroyed.complete();
            };
        /**
         * @return {?}
         */
        NgMentionsComponent.prototype.onWindowResize = /**
         * @return {?}
         */
            function () {
                this.refreshStyles();
            };
        /**
         * @return {?}
         */
        NgMentionsComponent.prototype.onTextAreaScroll = /**
         * @return {?}
         */
            function () {
                this.highlighterElement.nativeElement.scrollTop = this.textAreaInputElement.nativeElement.scrollTop;
            };
        /**
         * @param {?} event
         * @return {?}
         */
        NgMentionsComponent.prototype.onSelect = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                this.selectionStart = event.target.selectionStart;
                this.selectionEnd = event.target.selectionEnd;
            };
        /**
         * @param {?} newPlainTextValue
         * @return {?}
         */
        NgMentionsComponent.prototype.onChange = /**
         * @param {?} newPlainTextValue
         * @return {?}
         */
            function (newPlainTextValue) {
                var _this = this;
                /** @type {?} */
                var value = this._value;
                /** @type {?} */
                var displayTransform = this.displayTransform.bind(this);
                /** @type {?} */
                var selectionStart = this.textAreaInputElement.nativeElement.selectionStart;
                /** @type {?} */
                var selectionEnd = this.textAreaInputElement.nativeElement.selectionEnd;
                /** @type {?} */
                var bounds = getBoundsOfMentionAtPosition(newPlainTextValue, this.markupSearch, selectionStart, displayTransform);
                if (bounds.start !== -1) {
                    newPlainTextValue = newPlainTextValue.substring(0, bounds.start) + newPlainTextValue.substring(bounds.end);
                }
                /** @type {?} */
                var newValue = applyChangeToValue(value, this.markupSearch, newPlainTextValue, this.selectionStart, this.selectionEnd, selectionEnd, displayTransform);
                /** @type {?} */
                var startOfMention = findStartOfMentionInPlainText(value, this.markupSearch, selectionStart, displayTransform);
                if (startOfMention.start > -1 && this.selectionEnd > startOfMention.start) {
                    selectionStart = startOfMention.start;
                    selectionEnd = selectionStart;
                }
                this.selectionStart = Math.max(selectionStart, 0);
                this.selectionEnd = Math.max(selectionEnd, 0);
                this.parseLines(newValue);
                if (this.selectionEnd > 0) {
                    setTimeout(function () { return setCaretPosition(_this.textAreaInputElement.nativeElement, _this.selectionEnd); });
                }
            };
        /**
         * @param {?} event
         * @return {?}
         */
        NgMentionsComponent.prototype.onInput = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                if (this.inputFallback && event.data) {
                    /** @type {?} */
                    var characterPressed = event.data;
                    /** @type {?} */
                    var keyCode = characterPressed.charCodeAt(0);
                    this.onKeyDown({ which: keyCode, keyCode: keyCode, key: characterPressed });
                }
            };
        /**
         * @param {?} event
         * @return {?}
         */
        NgMentionsComponent.prototype.onKeyDown = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                /** @type {?} */
                var caretPosition = getCaretPosition(this.textAreaInputElement.nativeElement);
                if (this.inputFallback) {
                    caretPosition--;
                }
                /** @type {?} */
                var characterPressed = event.key;
                /** @type {?} */
                var keyCode = event.which || event.keyCode;
                if (!characterPressed) {
                    /** @type {?} */
                    var characterCode = event.which || event.keyCode;
                    characterPressed = String.fromCharCode(characterCode);
                    if (!event.shiftKey && (characterCode >= 65 && characterCode <= 90)) {
                        characterPressed = String.fromCharCode(characterCode + 32);
                    }
                }
                this.inputFallback = keyCode === 229;
                if (this.inputFallback) {
                    return;
                }
                if (event && event.stopPropagation) {
                    event.stopPropagation();
                }
                if (keyCode === Key.Escape) {
                    this.escapePressed.emit();
                }
                if (this.commitOnCMDEnter && keyCode === Key.Enter && event.metaKey) {
                    this.cmdEnter.emit();
                    event.preventDefault();
                    return;
                }
                if (keyCode === Key.Enter && event.wasSelection && caretPosition < this.startPos) {
                    caretPosition = this.startNode.length;
                    setCaretPosition(this.startNode, caretPosition);
                }
                /** @type {?} */
                var startOfMention = findStartOfMentionInPlainText(this._value, this.markupSearch, caretPosition, this.displayTransform.bind(this));
                if (characterPressed === this.triggerChar) {
                    this.setupMentionsList(caretPosition);
                }
                else if (startOfMention.start === -1 && this.startPos >= 0) {
                    if (caretPosition <= this.startPos) {
                        this.mentionsList.show = false;
                        this.startPos = -1;
                    }
                    else if (keyCode !== Key.Shift && !event.shiftKey && !event.metaKey && !event.altKey && !event.ctrlKey &&
                        caretPosition > this.startPos) {
                        this.handleKeyDown(event, caretPosition, characterPressed);
                    }
                }
                else {
                    this.onSelect({ target: this.textAreaInputElement.nativeElement });
                }
            };
        /**
         * @param {?} event
         * @return {?}
         */
        NgMentionsComponent.prototype.onBlur = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                if (event instanceof FocusEvent && event.relatedTarget) {
                    /** @type {?} */
                    var element = ( /** @type {?} */(event.relatedTarget));
                    if (element.classList.contains('dropdown-item') || element.classList.contains('keep-focus')) {
                        return;
                    }
                }
                this.stopEvent(event);
                if (this.mentionsList) {
                    this.mentionsList.show = false;
                }
                this.focused = false;
                this.focusLost.emit();
            };
        /**
         * @param {?} event
         * @return {?}
         */
        NgMentionsComponent.prototype.onFocus = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                this.focused = true;
                this.focusIn.emit(event);
            };
        /**
         * @param {?} part
         * @return {?}
         */
        NgMentionsComponent.prototype.isPartMention = /**
         * @param {?} part
         * @return {?}
         */
            function (part) {
                return typeof part.contents !== 'undefined';
            };
        /**
         * @param {?} mention
         * @return {?}
         */
        NgMentionsComponent.prototype.formatMention = /**
         * @param {?} mention
         * @return {?}
         */
            function (mention) {
                return this._formatMention(mention.contents);
            };
        /**
         * @param {...?} _
         * @return {?}
         */
        NgMentionsComponent.prototype.displayTransform = /**
         * @param {...?} _
         * @return {?}
         */
            function () {
                var _ = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    _[_i] = arguments[_i];
                }
                /** @type {?} */
                var replaceIndex = this.markupSearch.groups[this.displayName];
                return (this.includeTriggerChar ? '@' : '') + _[replaceIndex];
            };
        /**
         * @param {?} contents
         * @return {?}
         */
        NgMentionsComponent.prototype._formatMention = /**
         * @param {?} contents
         * @return {?}
         */
            function (contents) {
                /** @type {?} */
                var replaceValue = "$" + this.displayName;
                /** @type {?} */
                var replaceIndex;
                /** @type {?} */
                var result = contents.replace(this.markupSearch.regEx, replaceValue);
                if (result === replaceValue) {
                    replaceIndex = (this.includeTriggerChar ? '@' : '') + ("$" + this.markupSearch.groups[this.displayName]);
                    result = contents.replace(this.markupSearch.regEx, replaceIndex);
                }
                return result;
            };
        /**
         * @param {?} event
         * @return {?}
         */
        NgMentionsComponent.prototype.stopEvent = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                if (event.preventDefault) {
                    event.preventDefault();
                    event.stopPropagation();
                    event.stopImmediatePropagation();
                }
            };
        /**
         * @param {?} caretPosition
         * @return {?}
         */
        NgMentionsComponent.prototype.setupMentionsList = /**
         * @param {?} caretPosition
         * @return {?}
         */
            function (caretPosition) {
                this.startPos = caretPosition;
                this.startNode = window.getSelection().anchorNode;
                this.searchString = '';
                this.stopSearch = false;
                this.showMentionsList();
                this.updateMentionsList();
            };
        /**
         * @param {?} event
         * @param {?} caretPosition
         * @param {?} characterPressed
         * @return {?}
         */
        NgMentionsComponent.prototype.handleKeyDown = /**
         * @param {?} event
         * @param {?} caretPosition
         * @param {?} characterPressed
         * @return {?}
         */
            function (event, caretPosition, characterPressed) {
                var _this = this;
                /** @type {?} */
                var keyCode = event.which || event.keyCode;
                if (keyCode === Key.Space) {
                    this.startPos = -1;
                }
                else if (keyCode === Key.Backspace && caretPosition > 0) {
                    caretPosition--;
                    if (caretPosition === this.startPos) {
                        this.stopSearch = true;
                    }
                    this.mentionsList.show = !this.stopSearch;
                }
                else if (this.mentionsList.show) {
                    if (keyCode === Key.Tab || keyCode === Key.Enter) {
                        this.stopEvent(event);
                        this.mentionsList.show = false;
                        /** @type {?} */
                        var value = this._value;
                        /** @type {?} */
                        var start = mapPlainTextIndex(value, this.markupSearch, this.startPos, false, this.displayTransform.bind(this));
                        /** @type {?} */
                        var item = event.item || this.mentionsList.selectedItem;
                        /** @type {?} */
                        var newValue = replacePlaceholders(item, this.markupSearch);
                        /** @type {?} */
                        var newDisplayValue = this._formatMention(newValue);
                        caretPosition = this.startPos + newDisplayValue.length;
                        /** @type {?} */
                        var searchString = this.searchString || '';
                        value = value.substring(0, start) + newValue + value.substring(start + searchString.length + 1, value.length);
                        this.parseLines(value);
                        this.startPos = -1;
                        this.searchString = '';
                        this.stopSearch = true;
                        this.mentionsList.show = false;
                        this.mentionsList.resetScroll();
                        this.changeDetector.detectChanges();
                        setTimeout(function () {
                            setCaretPosition(_this.textAreaInputElement.nativeElement, caretPosition);
                            _this.onSelect({ target: _this.textAreaInputElement.nativeElement });
                        });
                        return;
                    }
                    else if (keyCode === Key.Escape) {
                        this.stopEvent(event);
                        this.mentionsList.show = false;
                        this.stopSearch = true;
                        return;
                    }
                    else if (keyCode === Key.ArrowDown) {
                        this.stopEvent(event);
                        this.mentionsList.selectNextItem();
                        return;
                    }
                    else if (keyCode === Key.ArrowUp) {
                        this.stopEvent(event);
                        this.mentionsList.selectPreviousItem();
                        return;
                    }
                    else if (keyCode === Key.Home) {
                        this.stopEvent(event);
                        this.mentionsList.selectFirstItem();
                        return;
                    }
                    else if (keyCode === Key.End) {
                        this.stopEvent(event);
                        this.mentionsList.selectLastItem();
                        return;
                    }
                }
                if (keyCode === Key.ArrowLeft || keyCode === Key.ArrowRight || keyCode === Key.Home || keyCode === Key.End) {
                    this.onSelect(event);
                    return;
                }
                /** @type {?} */
                var mention = this.displayContent.substring(this.startPos + 1, caretPosition);
                if (keyCode !== Key.Backspace) {
                    mention += characterPressed;
                }
                this.searchString = mention || '';
                this.updateMentionsList();
            };
        /**
         * @param {?} item
         * @return {?}
         */
        NgMentionsComponent.prototype.getDisplayValue = /**
         * @param {?} item
         * @return {?}
         */
            function (item) {
                if (typeof item === 'string') {
                    return item;
                }
                else if (item[this.displayName] !== undefined) {
                    return item[this.displayName];
                }
                return null;
            };
        /**
         * @return {?}
         */
        NgMentionsComponent.prototype.showMentionsList = /**
         * @return {?}
         */
            function () {
                var _this = this;
                if (!this.mentionsList) {
                    /** @type {?} */
                    var componentFactory = this.componentResolver.resolveComponentFactory(NgMentionsListComponent);
                    /** @type {?} */
                    var componentRef = this.viewContainer.createComponent(componentFactory);
                    this.mentionsList = componentRef.instance;
                    this.mentionsList.itemTemplate = this.mentionListItemTemplate;
                    this.mentionsList.headerTemplate = this.mentionListHeaderTemplate;
                    this.mentionsList.displayTransform = this.displayTransform.bind(this);
                    this.mentionsList.itemSelected.subscribe(function (item) {
                        _this.textAreaInputElement.nativeElement.focus();
                        /** @type {?} */
                        var fakeEvent = { keyCode: Key.Enter, wasSelection: true, item: item };
                        _this.onKeyDown(fakeEvent);
                    });
                    this.mentionsList.displayTransform = this.getDisplayValue.bind(this);
                }
                this.mentionsList.textAreaElement = this.textAreaInputElement.nativeElement;
                this.mentionsList.show = true;
                this.mentionsList.dropUp = this.dropUp;
                this.mentionsList.activeIndex = 0;
                this.mentionsList.position();
                this.ngZone.run(function () { return _this.mentionsList.resetScroll(); });
            };
        /**
         * @return {?}
         */
        NgMentionsComponent.prototype.updateMentionsList = /**
         * @return {?}
         */
            function () {
                var _this = this;
                if (!this.disableSearch) {
                    /** @type {?} */
                    var items = Array.from(this.mentions);
                    if (this.searchString) {
                        /** @type {?} */
                        var searchString = this.searchString.toLowerCase();
                        /** @type {?} */
                        var searchRegEx_1 = new RegExp(escapeRegExp(searchString), 'i');
                        items = items.filter(function (item) {
                            /** @type {?} */
                            var value = _this.getDisplayValue(item);
                            return value !== null && searchRegEx_1.test(value);
                        });
                        if (this.maxItems > 0) {
                            items = items.slice(0, this.maxItems);
                        }
                    }
                    this.mentionsList.items = items;
                }
                else {
                    this.search.emit(this.searchString);
                }
            };
        /**
         * @return {?}
         */
        NgMentionsComponent.prototype.parseMarkup = /**
         * @return {?}
         */
            function () {
                if (this.mentionMarkup.length === 0 || this.mentionMarkup[0] !== this.triggerChar) {
                    throw new Error("ng-mentions markup pattern must start with the trigger character \"" + this.triggerChar + "\"");
                }
                this.markupSearch = markupToRegExp(this.mentionMarkup);
            };
        /**
         * @param {?=} value
         * @return {?}
         */
        NgMentionsComponent.prototype.parseLines = /**
         * @param {?=} value
         * @return {?}
         */
            function (value) {
                var _this = this;
                if (value === void 0) {
                    value = '';
                }
                if (value !== this._value) {
                    value = value || '';
                    /** @type {?} */
                    var lines = value.split(this.newLine).map(function (line) { return _this.formatMentions(line); });
                    /** @type {?} */
                    var displayContent = lines.map(function (line) { return line.content; }).join('\n');
                    if (this.displayContent !== displayContent) {
                        this.lines = lines;
                        this.displayContent = displayContent;
                        this.triggerChange(value);
                    }
                }
                this.empty = !value;
            };
        /**
         * @param {?} line
         * @return {?}
         */
        NgMentionsComponent.prototype.formatMentions = /**
         * @param {?} line
         * @return {?}
         */
            function (line) {
                var _this = this;
                /** @type {?} */
                var lineObj = ( /** @type {?} */({ originalContent: line, content: line, parts: [] }));
                if (line.length === 0) {
                    return lineObj;
                }
                /** @type {?} */
                var tags = [];
                /** @type {?} */
                var mention;
                /** @type {?} */
                var regEx = this.markupSearch.regEx;
                regEx.lastIndex = 0;
                while ((mention = regEx.exec(line)) !== null) {
                    tags.push({ indices: { start: mention.index, end: mention.index + mention[0].length } });
                }
                /** @type {?} */
                var prevTags = [];
                /** @type {?} */
                var content = '';
                __spread(tags).sort(function (tagA, tagB) { return tagA.indices.start - tagB.indices.start; }).forEach(function (tag) {
                    /** @type {?} */
                    var expectedLength = tag.indices.end - tag.indices.start;
                    /** @type {?} */
                    var contents = line.slice(tag.indices.start, tag.indices.end);
                    if (contents.length === expectedLength) {
                        /** @type {?} */
                        var prevIndex = prevTags.length > 0 ? prevTags[prevTags.length - 1].indices.end : 0;
                        /** @type {?} */
                        var before = line.slice(prevIndex, tag.indices.start);
                        /** @type {?} */
                        var partMention = ( /** @type {?} */({ contents: contents, tag: tag }));
                        lineObj.parts.push(before);
                        lineObj.parts.push(partMention);
                        prevTags.push(tag);
                        content += before + _this.formatMention(partMention);
                    }
                });
                /** @type {?} */
                var remainingStart = prevTags.length > 0 ? prevTags[prevTags.length - 1].indices.end : 0;
                /** @type {?} */
                var remaining = line.slice(remainingStart);
                lineObj.parts.push(remaining);
                content += remaining;
                lineObj.content = content;
                return lineObj;
            };
        /**
         * @return {?}
         */
        NgMentionsComponent.prototype.refreshStyles = /**
         * @return {?}
         */
            function () {
                var _this = this;
                /** @type {?} */
                var element = this.textAreaInputElement.nativeElement;
                if (this.autoexpand) {
                    // Reset textarea height to auto that correctly calculate the new height
                    element.style.height = 'auto';
                    // Set new height
                    element.style.height = element.scrollHeight + "px";
                }
                /** @type {?} */
                var computedStyle = getComputedStyle(element);
                this.highlighterStyle = {};
                styleProperties.forEach(function (prop) {
                    _this.highlighterStyle[prop] = computedStyle[prop];
                });
                this.changeDetector.detectChanges();
            };
        /**
         * @param {?} value
         * @return {?}
         */
        NgMentionsComponent.prototype.triggerChange = /**
         * @param {?} value
         * @return {?}
         */
            function (value) {
                this._value = value;
                this.valueChanges.emit(this._value);
                this.changeDetector.detectChanges();
            };
        NgMentionsComponent.decorators = [
            { type: core.Component, args: [{
                        exportAs: 'ngMentions',
                        selector: 'ng-mentions',
                        template: "<div #highlighter class=\"highlighter\" [ngClass]=\"textAreaClassNames\" [attr.readonly]=\"readonly\"\n     [ngStyle]=\"highlighterStyle\">\n  <div *ngFor=\"let line of lines\" class=\"lines\" [class.has-parsed-content]=\"parsedContent\">\n    <ng-container *ngFor=\"let part of line.parts\">\n      <highlighted *ngIf=\"isPartMention(part)\" [tag]=\"part.tag\">{{formatMention(part)}}</highlighted>\n      <ng-container *ngIf=\"!isPartMention(part)\">{{part}}</ng-container>\n    </ng-container>\n    &nbsp;\n  </div>\n  <div class=\"parsed-content\" (click)=\"input.focus()\" [hidden]=\"!parsedContent\" [innerHTML]=\"parsedContent\"></div>\n</div>\n<textarea\n  #input\n  [rows]=\"rows\"\n  [cols]=\"columns\"\n  [ngModel]=\"displayContent\"\n  [ngClass]=\"textAreaClassNames\"\n  (keydown)=\"onKeyDown($event)\"\n  (input)=\"onInput($event)\"\n  (blur)=\"onBlur($event)\"\n  (select)=\"onSelect($event)\"\n  (focus)=\"onFocus($event)\"\n  (mouseup)=\"onSelect($event)\"\n  (ngModelChange)=\"onChange($event)\"\n  (scroll)=\"onTextAreaScroll()\"\n  [disabled]=\"disabled\"\n  [required]=\"required\"\n  [placeholder]=\"placeholder\"\n></textarea>\n",
                        preserveWhitespaces: false,
                        encapsulation: core.ViewEncapsulation.None,
                        styles: ["ng-mentions{position:relative}ng-mentions textarea{position:relative;background-color:transparent!important;opacity:0}ng-mentions .highlighter{position:absolute;top:0;left:0;right:0;bottom:0;overflow:hidden!important}ng-mentions .highlighter .lines{white-space:pre-wrap}ng-mentions .highlighter .lines.has-parsed-content{display:none}ng-mentions .highlighter .parsed-content{display:block}ng-mentions highlighted{display:inline;border-radius:3px;padding:1px;margin:-1px;overflow-wrap:break-word}ng-mentions.focused .highlighter highlighted{background-color:#add8e6;color:transparent}ng-mentions.focused .highlighter .lines,ng-mentions.focused .highlighter .lines.has-parsed-content{color:transparent;display:block}ng-mentions.focused .highlighter .parsed-content{display:none}ng-mentions.empty textarea,ng-mentions.focused textarea{opacity:1}"]
                    }] }
        ];
        /** @nocollapse */
        NgMentionsComponent.ctorParameters = function () {
            return [
                { type: core.ElementRef },
                { type: core.ComponentFactoryResolver },
                { type: core.ViewContainerRef },
                { type: core.ChangeDetectorRef },
                { type: core.NgZone }
            ];
        };
        NgMentionsComponent.propDecorators = {
            triggerChar: [{ type: core.Input, args: ['triggerChar',] }],
            includeTriggerChar: [{ type: core.Input, args: ['includeTriggerChar',] }],
            mentionMarkup: [{ type: core.Input, args: ['markup',] }],
            disableSearch: [{ type: core.Input, args: ['disableSearch',] }],
            maxItems: [{ type: core.Input, args: ['maxItems',] }],
            dropUp: [{ type: core.Input, args: ['dropUp',] }],
            displayName: [{ type: core.Input, args: ['displayName',] }],
            formClass: [{ type: core.Input, args: ['formClass',] }],
            placeholder: [{ type: core.Input, args: ['placeholder',] }],
            value: [{ type: core.Input, args: ['value',] }],
            required: [{ type: core.Input, args: ['required',] }],
            disabled: [{ type: core.Input, args: ['disabled',] }],
            rows: [{ type: core.Input, args: ['rows',] }],
            columns: [{ type: core.Input, args: ['cols',] }],
            mentionItems: [{ type: core.Input, args: ['mentions',] }],
            parsedContent: [{ type: core.Input }],
            autoexpand: [{ type: core.Input }],
            commitOnCMDEnter: [{ type: core.Input }],
            mentionListItemTemplate: [{ type: core.Input }],
            mentionListHeaderTemplate: [{ type: core.Input }],
            search: [{ type: core.Output, args: ['search',] }],
            valueChanges: [{ type: core.Output, args: ['valueChanges',] }],
            stateChanges: [{ type: core.Output, args: ['stateChanges',] }],
            focusIn: [{ type: core.Output, args: ['focusIn',] }],
            focusLost: [{ type: core.Output, args: ['focusLost',] }],
            escapePressed: [{ type: core.Output, args: ['escapePressed',] }],
            cmdEnter: [{ type: core.Output, args: ['cmdEnter',] }],
            textAreaInputElement: [{ type: core.ViewChild, args: ['input',] }],
            highlighterElement: [{ type: core.ViewChild, args: ['highlighter',] }],
            focused: [{ type: core.HostBinding, args: ['class.focused',] }],
            empty: [{ type: core.HostBinding, args: ['class.empty',] }],
            onWindowResize: [{ type: core.HostListener, args: ['window:resize',] }]
        };
        return NgMentionsComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
     */
    /**
     * The NgMentionsAccessorDirective directive is used to indicate the input element.
     */
    var NgMentionsAccessorDirective = /** @class */ (function () {
        function NgMentionsAccessorDirective(element, host) {
            this.element = element;
            this.host = host;
            this._destroyed = new rxjs.Subject();
        }
        /**
         * @return {?}
         */
        NgMentionsAccessorDirective.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this.host.valueChanges.pipe(operators.takeUntil(this._destroyed)).subscribe(function (value) { return _this.onChange(value); });
            };
        /**
         * @return {?}
         */
        NgMentionsAccessorDirective.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                this._destroyed.next();
                this._destroyed.complete();
            };
        /**
         * @param {?} fn
         * @return {?}
         */
        NgMentionsAccessorDirective.prototype.registerOnChange = /**
         * @param {?} fn
         * @return {?}
         */
            function (fn) {
                this._onChange = fn;
            };
        /**
         * @param {?} fn
         * @return {?}
         */
        NgMentionsAccessorDirective.prototype.registerOnTouched = /**
         * @param {?} fn
         * @return {?}
         */
            function (fn) {
                this._onTouch = fn;
            };
        /**
         * @param {?} isDisabled
         * @return {?}
         */
        NgMentionsAccessorDirective.prototype.setDisabledState = /**
         * @param {?} isDisabled
         * @return {?}
         */
            function (isDisabled) {
                this.host.disabled = isDisabled;
            };
        /**
         * @param {?} value
         * @return {?}
         */
        NgMentionsAccessorDirective.prototype.writeValue = /**
         * @param {?} value
         * @return {?}
         */
            function (value) {
                if (typeof value === 'string' || value === null) {
                    this.host.value = value;
                }
            };
        /**
         * @param {?} value
         * @return {?}
         */
        NgMentionsAccessorDirective.prototype.onChange = /**
         * @param {?} value
         * @return {?}
         */
            function (value) {
                if (this._onChange) {
                    this._onChange(value);
                }
            };
        /**
         * @return {?}
         */
        NgMentionsAccessorDirective.prototype.onTouched = /**
         * @return {?}
         */
            function () {
                if (this._onTouch) {
                    this._onTouch();
                }
            };
        NgMentionsAccessorDirective.decorators = [
            { type: core.Directive, args: [{
                        exportAs: 'ngMentions',
                        selector: 'ng-mentions',
                        host: { '(change)': 'onChange($event)', '(touch)': 'onTouched()' },
                        providers: [{ provide: forms.NG_VALUE_ACCESSOR, useExisting: core.forwardRef(function () { return NgMentionsAccessorDirective; }), multi: true }]
                    },] }
        ];
        /** @nocollapse */
        NgMentionsAccessorDirective.ctorParameters = function () {
            return [
                { type: core.ElementRef },
                { type: NgMentionsComponent }
            ];
        };
        return NgMentionsAccessorDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
     */
    var HighlightedDirective = /** @class */ (function () {
        function HighlightedDirective() {
        }
        HighlightedDirective.decorators = [
            { type: core.Directive, args: [{ selector: 'highlighted' },] }
        ];
        HighlightedDirective.propDecorators = {
            tag: [{ type: core.Input }]
        };
        return HighlightedDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
     */
    /** @type {?} */
    var EXPORT_DIRECTIVES = [NgMentionsComponent, NgMentionsAccessorDirective];
    /** @type {?} */
    var DECLARATIONS = [NgMentionsComponent, NgMentionsAccessorDirective, NgMentionsListComponent, HighlightedDirective];
    var NgMentionsModule = /** @class */ (function () {
        function NgMentionsModule() {
        }
        NgMentionsModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule, forms.FormsModule],
                        exports: EXPORT_DIRECTIVES,
                        declarations: DECLARATIONS,
                        entryComponents: [NgMentionsListComponent]
                    },] }
        ];
        return NgMentionsModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
     */

    exports.NgMentionsAccessorDirective = NgMentionsAccessorDirective;
    exports.NgMentionsComponent = NgMentionsComponent;
    exports.NgMentionsModule = NgMentionsModule;
    exports.ɵb = HighlightedDirective;
    exports.ɵa = NgMentionsListComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=ng-mentions.umd.js.map